#include <iostream>
#include <FL/Fl.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Export.H>
#include <FL/Fl_Window.H>
#include <FL/fl_draw.H>
#include <unistd.h>
#include "Mouse_Status.hpp"
#include "vkvm.hpp"
#include "internal.hpp"
#include "Image.hpp"

#ifndef GUI_GUI_HPP
#define GUI_GUI_HPP

/** GUI_Window
 * The GUI_Window-class generates a window, within the window it recognizes the curretn mouse-position.
 * It also recognizes if a button is pushed on the keyboard or the mouse. Furthermore the class depict the
 * content of the Image-class and provides functions to refresh it.
 * @param x The mouse-position on the x-axis.
 * @param y The mouse-position on the y-axis.
 * @param button The button that was pushed last.
 */
class GUI_Window : public Fl_Window {
    int x, y, button,lastX,lastY,mouse_status;
    vkvm::KeyCode keyCode;

    int handle(int e) override;

    static char *position_to_string(int x, int y);

public:
    GUI_Window(int x, int y, const char *l);
};
#endif //GUI_GUI_HPP
